// Copyright 2017-2025 WIT.COM Inc. All rights reserved.
// Use of this source code is governed by the GPL 3.0

package main

/*
	this enables command line options from other packages like 'gui' and 'log'
*/

import (
	"go.wit.com/log"
)

var NOW *log.LogFlag
var INFO *log.LogFlag
var GOCUI *log.LogFlag

var SPEW *log.LogFlag
var WARN *log.LogFlag

var ERROR *log.LogFlag

func init() {
	full := "go.wit.com/gui"
	short := "gocui"

	GOCUI = log.NewFlag("GOCUI", true, full, short, "gocui internals")

	full = "go.wit.com/toolkits/gocui"
	short = "gocui"

	NOW = log.NewFlag("NOW", true, full, short, "temp debugging stuff")
	INFO = log.NewFlag("INFO", false, full, short, "normal debugging stuff")

	WARN = log.NewFlag("WARN", true, full, short, "bad things")
	SPEW = log.NewFlag("SPEW", false, full, short, "spew stuff")

	ERROR = log.NewFlag("ERROR", true, full, short, "toolkit errors")
}
